<script setup lang="ts">
import { onBeforeMount, onMounted, computed } from "vue";
import { useAuthStore } from "@/stores/users";
import { useRouter } from "vue-router";
import { OpenAPI } from "@/client";
import { Toast } from "bootstrap";
import BootstrapToast from "@/components/BootstrapToast.vue";

const router = useRouter();

const props = defineProps<{
  returnPath?: string;
  loginError?: string;
}>();

const store = useAuthStore();

let errorToast: Toast | null = null;

onBeforeMount(() => {
  if (store.authenticated) {
    // If user is authenticated redirect him to the dashboard
    router.push({ name: "buckets" });
  }
});

const returnPathQuery = computed<string>(() =>
  props.returnPath ? `&return_path=${encodeURI(props.returnPath)}` : "",
);

onMounted(() => {
  errorToast = new Toast("#loginErrorToast");
  // if there is a query param 'login_error' show the error toast
  if (props.loginError) {
    errorToast?.show();
  }
});
</script>

<template>
  <bootstrap-toast toast-id="loginErrorToast" color-class="danger">
    <template #default> Login Error</template>
    <template #body>
      <p>
        There has been some kind of error during the login.<br />
        Please try again later.
      </p>
      <p>Error Code: {{ props.loginError }}</p>
    </template>
  </bootstrap-toast>
  <div
    class="card text-center ms-md-auto position-fixed top-50 start-50 translate-middle shadow"
  >
    <div class="card-header">Login</div>
    <div class="card-body">
      <p class="card-text text-secondary">
        Login to this service with LifeScience
      </p>
      <a
        :href="`${OpenAPI.BASE}/auth/login?provider=lifescience${returnPathQuery}`"
        class="m-2"
      >
        <img src="/src/assets/images/ls-login.png" alt="[LS Login]" />
      </a>
    </div>
  </div>
</template>

<style scoped>
a > img:hover {
  filter: brightness(0.9);
}

.green {
  color: #198754;
}

.red {
  color: #dc3545;
}

.blue {
  color: #0d6efd;
}
</style>
